from bucketresources import BucketResource
from apps import ApplicationModule


class Datacentre:
    def __init__(self):
        self.processingpower: BucketResource = BucketResource()
        self.uplink: BucketResource = BucketResource()

    def fireapplicationmodule(self, applicationmodule: ApplicationModule) -> bool:
        return self.processingpower.reserve(applicationmodule.cpuRequirement) and self.uplink.reserve(
            applicationmodule.bwRequirement)

    def releaseall(self) -> None:
        self.processingpower.releaseall()
        self.uplink.releaseall()
